#!/bin/sh
#
#######################################################
# Prefixe des thumbnails
prefixe="tn_"
########################################################
# Realisation Steve Lussiaud - 2005
# Contact : steve.lussiaud@free.fr
# Publi sous Licence GNU/GPL
########################################################
# Objet : Cration des vignettes pour PHP WEB GALLERY en local 
# Version : 0.2 (20050914)
# OS : GNU/Linux
# Pre-Requis : Image Magick; gawk ; Avoir les permissions en
# 	       lecture-ecriture dans le dossier.
# Site du soft : http://www.phpwebgallery.net
########################################################
# Utilisation :
# Placez le script dans le dossier contenant vos galleries
# Placez vos images dans les galeries 
# Il ne vous reste plus qu' lancer le script pour automatiser
# la cration des vignettes, des dossiers thumbnails
# N'oubliez pas de donner les permissions d'execution : 
# chmod u+x script.sh
# Lancement : ./update_gallery.sh
#######################################################
# Debut du programme 
########################################################
# Recuperation des repertoires differents de thumbnail
for j in `find . -name "*" -type d | grep -v thumbnail`
	do
		echo "Traitement $j en cours ...."
		# Test si le dossier thumbnail existe
		if [ -d $j/thumbnail ];then
			echo "+ Repertoire thumbnail present"
		else
			# Si le repertoire Thumbnail n'existe pas alors creation
			mkdir $j/thumbnail
			echo "+ Repertoire thumbnail inexistant => Cre"
		fi
		# Test si le fichier index.html existe sinon creation
		if [ -e $j/index.html ];then
			echo "+ Fichier de redirection HTML prsent dans le repertoire"
		else
			# Creation du fichier HTML pour redirection
			echo "<HTML><HEAD><meta http-equiv='REFRESH' content='0; URL=http://www.google.fr/'></HEAD></HTML>" > $j/index.html
			cp -f $j/index.hml $j/thumbnail/index.html
			echo "+ Creation fichiers HTML termines"
		fi
			# Calcul le nombre d'images dans le dossier des images du repertoire en cours
			nb_picture=`find $j \( -name "*.jpg" -or -name "*.png" -or -name "*.gif" \) -type f -maxdepth 1 | wc -l`
			echo "+ $nb_picture fichiers presents dans $j"

			# Calcul le nombre d'images dans le dossier thumbnail du repertoire en cours
			nb_thumb=`find $j/thumbnail \( -name "*.jpg" -or -name "*.png" -or -name "*.gif" \) -type f -maxdepth 1 | wc -l`
			echo "+ $nb_thumb fichiers presents dans $j/thumbnail"

			# Si les nombres d'images sont differents
			if [ $nb_picture -ne $nb_thumb ];then
				echo "  +--> MISE A JOUR NECESSAIRE !!!"
				#Stock les le chemins des images dans un fichier texte
				
				for z in `find $j \( -name "*.jpg" -or -name "*.png" -or -name "*.gif" \) -type f -maxdepth 1`
				do
					base_filename=`basename $z`
					if [ -e $j/thumbnail/tn_$base_filename ]; then
						echo "+ Aucun fichier a convertir"
					else
						# Conversion des images et enregistrement du resultat dans le rep thumbnail
						convert -sample 128x96 $j/$base_filename $j/thumbnail/tn_$base_filename
					fi
				done
			fi

		# Ajout un saut de ligne
		echo " "
	done
